SystemOrganization addCategory: #'PetitGui-Core'!

!PPAndParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:44'!
exampleOn: aStream! !

!PPAndParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:43'!
morphicShapeSeen: aSet depth: anInteger
	aSet add: self.
	^ parser morphicShapeSeen: aSet depth: anInteger! !

!PPChoiceParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:24'!
exampleOn: aStream
	parsers atRandom exampleOn: aStream! !

!PPChoiceParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/7/2009 15:09'!
morphicShapeSeen: aSet depth: anInteger
	| morph |
	^ (anInteger < 1 or: [ aSet includes: self ])
		ifTrue: [ super morphicShapeSeen: aSet depth: anInteger ]
		ifFalse: [
			aSet add: self.
			morph := RectangleMorph new.
			morph 
				borderWidth: 0;
				color: Color transparent;
				layoutPolicy: TableLayout new;
				cellPositioning: #leftCenter;
				listDirection: #topToBottom;
				hResizing: #shrinkWrap;
				vResizing: #spaceFill;
				layoutInset: 5;
				cellInset: 5.
			self children
				do: [ :each | morph addMorphBack: (each morphicShapeSeen: aSet depth: anInteger - 1) ].
			morph ]! !

!PPEpsilonParser methodsFor: '*petitgui-mondrian' stamp: 'lr 11/6/2009 18:42'!
displayName
	^ 'epsilon'! !

!PPCompositeParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/6/2009 17:24'!
productions
	| productions |
	productions := OrderedCollection new.
	PPCompositeParser instSize + 1 to: self class instSize
		do: [ :index | productions add: (self instVarAt: index) ].
	^ productions! !

!PPLiteralParser methodsFor: '*petitgui-mondrian' stamp: 'lr 11/7/2009 13:31'!
displayName
	^ literal asString! !

!PPLiteralSequenceParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:25'!
exampleOn: aStream
	aStream nextPutAll: literal! !

!PPParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/6/2009 18:31'!
displayColor
	^ self isUnresolved
		ifTrue: [ Color red ]
		ifFalse: [ 
			self isNullable
				ifTrue: [ Color blue ]
				ifFalse: [ Color black ] ]! !

!PPParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/6/2009 18:31'!
displayName
	^ self name isNil
		ifFalse: [ self name asString ]
		ifTrue: [ self class name asString ]! !

!PPParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:37'!
example
	^ String streamContents: [ :stream | self exampleOn: stream ] limitedTo: 1024! !

!PPParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:20'!
exampleOn: aStream! !

!PPParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/7/2009 14:55'!
morphicShape
	^ self morphicShapeSeen: IdentitySet new depth: 2! !

!PPParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/7/2009 13:25'!
morphicShapeSeen: aSet depth: anInteger
	^ TextMorph new
		centered;
		autoFit: true;
		borderWidth: 1;	
		borderColor: Color black;
		backgroundColor: Color white;
		textColor: (self isTerminal
			ifTrue: [ Color purple ]
			ifFalse: [ Color blue ]);
		contents: self displayName;
		yourself! !

!PPParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/6/2009 16:52'!
productions
	^ #()! !

!PPSequenceParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:24'!
exampleOn: aStream
	parsers do: [ :each | each exampleOn: aStream ]! !

!PPSequenceParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/7/2009 15:11'!
morphicShapeSeen: aSet depth: anInteger
	| morph |
	^ (anInteger < 1 or: [ aSet includes: self ])
		ifTrue: [ super morphicShapeSeen: aSet depth: anInteger ]
		ifFalse: [
			aSet add: self.
			morph := RectangleMorph new.
			morph 
				borderWidth: 0;
				color: Color transparent;
				layoutPolicy: TableLayout new;
				cellPositioning: #leftCenter;
				listDirection: #leftToRight;
				hResizing: #shrinkWrap;
				vResizing: #spaceFill.
			morph addMorphBack: (LineMorph from: 0 @ 0 to: 20 @ 0 color: Color black width: 1) 	makeForwardArrow.
			self children
				do: [ :each | morph addMorphBack: (each morphicShapeSeen: aSet depth: anInteger - 1) ]
				separatedBy: [ morph addMorphBack: (LineMorph from: 0 @ 0 to: 20 @ 0 color: Color black width: 1) makeForwardArrow ].
			morph addMorphBack: ((LineMorph from: 0 @ 0 to: 20 @ 0 color: Color black width: 1) 
				"vResizing: #spaceFill;"
				makeForwardArrow;
				yourself).
			morph ]! !

!PPFlattenParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:28'!
exampleOn: aStream
	super exampleOn: aStream.
	aStream space! !

Object subclass: #PPBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitGui-Core'!

!PPBrowser class methodsFor: 'instance-creation' stamp: 'lr 11/6/2009 16:32'!
open
	^ self new open! !

!PPBrowser methodsFor: 'browse-parts' stamp: 'lr 11/9/2009 14:26'!
browseExampleOn: aBrowser
	aBrowser text
		title: 'Example';
		display: [ :parsers | parsers last example ]! !

!PPBrowser methodsFor: 'browse-parts' stamp: 'lr 11/9/2009 13:58'!
browseFirstOn: aBrowser
	aBrowser list
		title: 'First';
		format: [ :parser | parser displayName ];
		display: [ :parsers | parsers last firstSet ]! !

!PPBrowser methodsFor: 'browse-parts' stamp: 'lr 11/9/2009 13:58'!
browseFollowOn: aBrowser
	aBrowser list
		title: 'Follow';
		format: [ :parser | parser displayName ];
		display: [ :parsers | parsers last followSet ]! !

!PPBrowser methodsFor: 'browse-parts' stamp: 'lr 11/9/2009 13:55'!
browseGraphOn: aBrowser
	aBrowser morph
		title: 'Graph';
		display: [ :parsers |
			| morph |
			morph := ScrollPane new.
			morph scroller addMorph: parsers last morphicShape.
			morph ]! !

!PPBrowser methodsFor: 'browse' stamp: 'lr 11/9/2009 19:27'!
browseOn: aBrowser
	aBrowser title: 'PetitParser Browser'; color: Color purple lighter lighter.
	aBrowser column: #parsers; column: #production span: 3.
	
	aBrowser showOn: #parsers; using: [ 
		self browseParserOn: aBrowser ].
	aBrowser showOn: #production; from: #parsers -> #selectionPath; using: [
		self browseSourceOn: aBrowser.
		self browseTestOn: aBrowser.
		self browseGraphOn: aBrowser.
		self browseExampleOn: aBrowser.
		self browseFirstOn: aBrowser.
		self browseFollowOn: aBrowser ]! !

!PPBrowser methodsFor: 'browse-parts' stamp: 'lr 11/10/2009 21:25'!
browseParserOn: aBrowser
	aBrowser tree
		format: [ :parser | parser displayName ];
		children: [ :parser | 
			parser productions
				asSortedCollection: [ :a :b | a displayName < b displayName ] ];
		act: [ :node | 
			StandardToolSet
				browse: (self parserClassFor: node selectionPath)
				selector: (self parserSelectorFor: node selectionPath) ]
		on: $b entitled: 'browse (b)';
		act: [ :node :parsers | 
			| class selector |
			class := self parserClassFor: node selectionPath.
			selector := self parserSelectorFor: node selectionPath.
			selector = #start
				ifTrue: [ class removeFromSystem ]
				ifFalse: [
					(class allInstVarNames includes: selector asString)
						ifTrue: [ class removeInstVarName: selector asString ].
					class removeSelector: selector ] ]
		on: $x entitled: 'remove (x)'! !

!PPBrowser methodsFor: 'browse-parts' stamp: 'lr 11/10/2009 21:27'!
browseSourceOn: aBrowser
	aBrowser text
		title: 'Source';
		display: [ :parsers | 
			(self parserClassFor: parsers)
				sourceCodeAt: (self parserSelectorFor: parsers) ];
		forSmalltalk: [ :parsers | self parserClassFor: parsers ];
		act: [ :node :parsers | 
			| class selector |
			class := self parserClassFor: parsers.
			selector := class compile: node text asString.
			(selector numArgs = 0 and: [ (class allInstVarNames includes: selector asString) not ])
				ifTrue: [ class addInstVarName: selector asString ] ]
		on: $s entitled: 'accept (s)'
		! !

!PPBrowser methodsFor: 'browse-parts' stamp: 'lr 11/9/2009 19:48'!
browseTestOn: aBrowser
	| browser contents |
	browser := aBrowser table.
	browser title: 'Test'; row: #input; row: #output.
	
	contents := String new.
	browser showOn: #input; using: [
		browser text
			display: [ :parsers | contents ];
			update: #selection on: $s entitled: 'parse (s)' with: [ :presentation | 
				contents := presentation text copy ] ].
	browser showOn: #output; from: #outer -> #entity; from: #input; using: [
		browser text
			useExplicitNotNil;
			when: [ :parsers | parsers notNil ];
			display: [ :parsers :value | parsers last parse: contents asParserStream ] ]! !

!PPBrowser methodsFor: 'public' stamp: 'lr 11/9/2009 14:00'!
open
	| browser |
	browser := GLMTableLayoutBrowser new.
	self browseOn: browser.
	browser openOn: (PPCompositeParser allSubclasses
		collect: [ :class | class named: class name ])! !

!PPBrowser methodsFor: 'utilities' stamp: 'lr 11/10/2009 21:21'!
parserClassFor: anArray
	^ anArray isEmpty 
		ifFalse: [ anArray first class ]! !

!PPBrowser methodsFor: 'utilities' stamp: 'lr 11/10/2009 21:21'!
parserSelectorFor: anArray
	^ anArray size > 1
		ifTrue: [ anArray second name asSymbol ]
		ifFalse: [ #start ]! !

!PPPredicateParser methodsFor: '*petitgui-mondrian' stamp: 'lr 11/7/2009 14:21'!
displayName
	^ predicateMessage! !

!PPPredicateParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:34'!
exampleOn: aStream
	| valid normal |
	valid := Character allCharacters
		select: [ :char | predicate value: char ].
	normal := valid
		select: [ :char | char asInteger < 127 and: [ char isAlphaNumeric ] ].
	aStream nextPut: (normal isEmpty
		ifTrue: [ valid atRandom ]
		ifFalse: [ normal atRandom ])! !

!PPFailingParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/6/2009 18:43'!
displayColor
	^ Color red! !

!PPFailingParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/6/2009 18:43'!
displayName
	^ message! !

!PPRepeatingParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:42'!
exampleOn: aStream
	(min to: (max min: min + 5)) atRandom
		timesRepeat: [ super exampleOn: aStream ]! !

!PPRepeatingParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/7/2009 14:56'!
morphicShapeSeen: aSet depth: anInteger
	| morph |
	^ (anInteger < 1 or: [ aSet includes: self ])
		ifTrue: [ super morphicShapeSeen: aSet depth: anInteger ]
		ifFalse: [
			aSet add: self.
			morph := RectangleMorph new.
			morph 
				borderWidth: 1;
				color: Color transparent;
				layoutPolicy: TableLayout new;
				listDirection: #leftToRight;
				wrapCentering: #center;
				hResizing: #shrinkWrap;
				vResizing: #shrinkWrap;
				layoutInset: 0 @ 5.
			morph addMorphBack: (LineMorph from: 0 @ 0 to: 20 @ 0 color: Color black width: 1) makeForwardArrow.
			morph addMorphBack: (parser morphicShapeSeen: aSet depth: anInteger - 1).
			morph addMorphBack: (LineMorph from: 0 @ 0 to: 20 @ 0 color: Color black width: 1) makeForwardArrow.
			morph ]! !

!PPDelegateParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:27'!
exampleOn: aStream
	parser exampleOn: aStream! !

!PPDelegateParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/7/2009 14:58'!
morphicShapeSeen: aSet depth: anInteger
	aSet add: self.
	^ parser morphicShapeSeen: aSet depth: anInteger! !

!PPLiteralObjectParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:25'!
exampleOn: aStream
	aStream nextPut: literal! !
